/**
 *
 */
package de.intevation.gnv.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 * 
 */
public class DoExportAction extends DoOutputAction {

    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger log = Logger.getLogger(DoExportAction.class);

    /**
     * Constructor
     */
    public DoExportAction() {
        super();
    }

    @Override
    protected void setHeaders(String target, String mimeType,
                              HttpServletResponse response,
                              HttpServletRequest request) {
        log.debug("DoExportAction.setHeaders");
        try {
            super.setHeaders(target, mimeType, response, request);
            String fileName = "GNVEXPORT_" + System.currentTimeMillis() + ".";

            target = target.toLowerCase();

            if (target.equals("chart")) {
                fileName = fileName
                           + mimeType.substring(mimeType.indexOf("/") + 1);
            } 
            else if (target.equals("pdf")) {
                fileName = fileName + "pdf";
            } else if (target.equals("svg")) {
                fileName = fileName + "svg";
            } else if (target.equals("csv")) {
                fileName = fileName + "csv";
            } else if (target.equals("zip")) {
                fileName = fileName + "zip";
            } else if (target.equals("wms")) {
                fileName = fileName + "xml";
            } else {
                fileName = fileName + "txt";
            }
            log.debug("FileName for Export: " + fileName);
            response.setHeader("Content-Disposition", "attachment;filename="
                                                      + fileName);
        } catch (Exception e) {
            log.error(e, e);
        }
    }
}
